function enum_people(room)
    return function(room, ch)
        if room == nil then return nil
        elseif ch == nil then return room.people
        else return ch.next_in_room end
    end, room, nil
end

function enum_room_contents(room)
    return function(room, obj)
        if room == nil then return nil
        elseif obj == nil then return room.contents
        else return obj.next_content end
    end, room, nil
end

function enum_obj_contents(obj)
    return function(container, obj)
        if room == nil then return nil
        elseif obj == nil then return container.contains
        else return obj.next_content end
    end, obj, nil
end
-- ------------------------------------------------------------
--    index   x    1,    .
-- ,  ,       (   ):
-- x = {[1] = "s#!", [3] = "s#!"}
-- if index(x) and expression1 then
-- elseif index(x, 2) and expression2 then  end
-- local string_table = x.index --        
-- if string_table then  mob.action(table[string_table], ch) end
-- ------------------------------------------------------------
function index(table, delta)
    table.index = (table.index or 0) + (delta or 1)
    return true
end
-- ------------------------------------------------------------
--    ch   ,     , 
-- ch ,    ,  victim,   victim    ,  ch.
--    ch   "exec_next" (  event),    .
-- TODO       action,   .
-- ------------------------------------------------------------
function monologue(text, ch, victim)
    ch.set_var("exec_next", 1)
    for i = 1, #text do
        if not ch or ch.fighting or victim.fighting or ch.room ~= victim.room or ch.get_var("exec_next") == nil then
            return false
        end
        local sec = text[i][2]
        ch.set_var("speech", 1, (sec + 2).." sec")
        ch.execute(text[i][1])
        if sec > 0 then
            delay(sec)
        end
    end
    ch.remove_var("exec_next")
    return true
end
-- ------------------------------------------------------------
--       . 
--    (/).   
--    (   - nil (false),  number(true)).
--          !
-- ------------------------------------------------------------
function string_array_find(array, string)
    for i = 1, #array do
        if array[i] == string then
            return i
        end
    end
    return nil
end
-- ------------------------------------------------------------
--       .  
--    ,     . 
--   --    (   -
-- nil (false),  number(true)).
--          !
-- ------------------------------------------------------------
function check_answer(answers, answer)
    return string_array_find(answers, string.lower(answer))
end

function check_yesno_answer(positive_answers, negative_answers, answer)
    if check_answer(positive_answers, answer) then
        return 0
    elseif check_answer(negative_answers, answer) then
        return 1
    end
    return nil
end
-- ------------------------------------------------------------
--    ch  victim    /  
-- victim,    .
-- TODO ,      heap -      ,   ""   
-- TODO    ++  -     load obj 10*3397
-- TODO   c++   -     heap,   (  heap - ) ,
-- TODO   heap   (      )
-- ------------------------------------------------------------
stdlib_give_table = {
[true]  = { --      
"&ov@to_char",
"c#  $o-hv $Cd.", -- $o-hv -    heap items
"v#$n   $o-hv.",
"o#$n  $ov $Cd."},
[false] = { --   ,  
"&ov@to_char",
"c#  $o-hv $Cd.", -- $o-hv -    heap items
"v#$n   $o-hv.",
"o#$n  $ov $Cd."} }

function give_obj(ch, victim, obj)
    if valid(obj) then
        obj.to_char(victim)
        ch.action(stdlib_give_table[ch.room == victim.room], victim, obj)
    else
        Mud.log(string.format("BUG: give_obj() %s   %s  () ", ch.name, victim. name))
    end
end
-- ------------------------------------------------------------
--      ch  victim    /
--   victim,    ,   , 
--  .    .
-- ------------------------------------------------------------
function give_new_obj(ch, victim, obj_vnum, obj_weight) -- TODO   /
    local old_obj = victim.has_obj(obj_vnum)
    if old_obj and old_obj.has_flag("heap") then
        old_obj.set_flag("heap", 0)
    else
        old_obj = nil
    end

    local obj = victim.create_object(obj_vnum)
    if obj_weight then
        obj.weight = obj_weight
    end
    give_obj(ch, victim, obj)
--    ch.act("char", victim, obj, "  $ov $Cd.")
--    victim.act("char", ch, obj, "$N   $ov.")
    --victim.act("char", ch, obj, "$N   $o-hv.") -- TODO ,      heap -      ,   ""   
                                                                 --    ++  -     load obj 10*3397
--    ch.act("other vis_any", victim, obj, "$n  $ov $Cd.")
    if old_obj then
        old_obj.set_flag("heap", 1) --   heap
    end
    return obj
end
-- ------------------------------------------------------------
--     (   max_sum -   sum  max_sum)
--  ch  victim      victim,    
--   .    , ,  
--       . ,     
--  .          ,  .
-- TODO    ,      -    .
-- ------------------------------------------------------------
function give_gold(ch, victim, sum, max_sum)
    if max_sum then
        if sum > max_sum then
            Mud.log("  give_gold(),      "..ch.name)
        elseif sum ~= max_sum then
            sum = Mud.random_range(sum, max_sum)
        end
    end
    local sSum = gramnumber(sum, " ", " ", " ")
    if ch.is_pc() then
        ch.gold = ch.gold - sum
    else --   .   =)
        ch.gold = math.max(0, ch.gold - sum)
    end
    if victim.is_pc() then
        victim.gold = victim.gold + sum
    end
    ch.act("char", victim,  "  $Cd {C"..sum.." {Y"..sSum.."{w.")
    victim.act("char", ch, "$N   {C"..sum.." {Y"..sSum.."{w.")
    ch.act("notvict vis_any", victim, "$n  $Cd {Y {w.")
end
-- ------------------------------------------------------------
--  true    str   ()  , 
--   param,   false.       .
-- ------------------------------------------------------------
function recognize(str, param)
    if param ~= "" then
        for word in string.gmatch(str, "[^%s%p]+") do
            if word == param or word and (string.len(param) < string.len(word) and string.sub(word, 1, string.len(param)) == param) then
                return true
            end
        end
    end
    return false
end
-- ------------------------------------------------------------
--    (,   ..)     .
-- ------------------------------------------------------------
function trim(str)
    local n = str and string.find(str, "%S") or nil
    return n and string.match(str, ".*%S", n) or ""
end
-- ------------------------------------------------------------
--      .
-- ------------------------------------------------------------
function gramnumber(num, choice1, choice2, choice3)
    local remainder = num % 100
    if remainder < 11 or remainder > 14  then
        remainder = num % 10
        if remainder > 0 and remainder <= 4 then
            return remainder == 1 and choice1 or choice2
        end
    end
    return choice3
end
-- ------------------------------------------------------------
--   ,    ch (c   'change sex').
-- ------------------------------------------------------------
function gramsex(ch, neutral, male, female)
    if ch.sex == "male" then
        return male
    elseif ch.sex == "female" then
        return female
    end
    return neutral
end
-- ------------------------------------------------------------
--   ,     ch (   'change sex').
-- ------------------------------------------------------------
function gramtruesex(ch, neutral, male, female)
    if ch.true_sex == "male" then
        return male
    elseif ch.true_sex == "female" then
        return female
    end
    return neutral
end
-- ------------------------------------------------------------
--  time ~= nil          
--  diff    !
--    "  "      - ""
-- ------------------------------------------------------------
function difftime(time, diff)
    if not diff then
        diff = time - os.time()
    end
    if diff < 0 then
        return nil
    elseif diff < 60 then
        return tostring(diff).." "..gramnumber(diff, "", "", "")
    end
    diff = (diff - diff % 60) / 60
    local mins = diff % 60
    diff = (diff - mins) / 60
    local hours = diff % 24
    local days, result = (diff - hours) / 24
    if days > 0 then
        result = tostring(days).." "..gramnumber(days, "", "", "")
    end
    if hours > 0 then
        result = (result and result.." " or "")..hours.." "..gramnumber(hours, "", "", "")
    end
    if mins > 0 then
        return (result and result.." " or "")..mins.." "..gramnumber(mins, "", "", "")
    end
    return result
end
-- ------------------------------------------------------------
--      ,   -     .
-- ------------------------------------------------------------
function rnd_tab(rnd_table)
    return rnd_table[Mud.random_range(1, #rnd_table)] -- TODO ,      ,  ? (#        )
end
-- ------------------------------------------------------------
--   ch  ,   .
-- ------------------------------------------------------------
function do_execute(ch, list)
    if type(list) == "string" then
        list = { list }
    end
    local ch_execute, v = ch.execute
    for v,v in ipairs(list) do
        ch_execute(v)
    end    
end
-- ------------------------------------------------------------
--       .
-- ------------------------------------------------------------
global_invert_direction_table = {["w"] = "e", ["e"] = "w", ["n"] = "s", ["s"] = "n", ["u"] = "d", ["d"] = "u"}

function get_way_back(path)
    local table_insert, gidt, return_path_table, i = table.insert, global_invert_direction_table, {}
    path = string.lower(path)
    for i = 1, #path do
        table_insert(return_path_table, 1000 - i, gidt[string.sub(path, i)]) --          (    )
    end
    return table.concat(return_path_table) --   ,        ( table.insert)    -  
end

-- ------------------------------------------------------------
--   ch   act_for   list.
--      victim
-- ------------------------------------------------------------
function do_act(ch, act_for, victim, list)
    if type(list) == "string" then
        list = {list}
    end
    local ch_act, v = ch.act
    for v,v in ipairs(list) do
        ch_act(act_for, victim, v)
    end    
end
--[[  ch.action
-- ------------------------------------------------------------
--      (     )
--      tell victim text.    
-- male/female/neutral,      victim(//).
-- ------------------------------------------------------------
function do_tell_social(ch, victim, list)
    if type(list) == "string" then
        list = {list}
    end
	local mob_act, ch_sex, i, v = mob.act, ch.sex
    for i, v in pairs(list) do
        if type(i) ~= "string" or i == ch_sex then
            delay(1)
            if not valid(ch, mob) or mob.fighting or mob.is_sleeping() or mob.room ~= ch.room then
                return
            elseif string.sub(v, 1, 1) == " " then
                mob.social(trim(v), ch)
            else
                mob_act("victim", ch, "# $n   '{G"..v.."{w'")
            end
        end
    end
end]]
-- ------------------------------------------------------------
-- ,      -     (  )
--   ,       1  (   npc).
-- ------------------------------------------------------------
function obj_act_to_room(obj, message)
    local room = obj.carried_by and obj.carried_by.room or obj.in_room --     ( nil,  obj  )
    if room and room.players > 0 then --       1  pc,     
        room.people.act("all", obj, message)
    end
end
-- ------------------------------------------------------------
--  act  ch  victim,   to_act,    format_string,  
-- c language-style: %c -, %d -  , %s -     .  .
-- ------------------------------------------------------------
function act_format_str(ch, victim, to_act, format_string, ...)
    ch.act(to_act, victim, string.format(format_string, ...))
end
-- ------------------------------------------------------------
--     ,   . 
--       . 
--   ,    .
-- ------------------------------------------------------------
function get_num(value)
    return type(value) == "number" and value or 0
end
-- ------------------------------------------------------------
--    ,   .    ,   ,
--    ,     mob_or_room.
--       vnum- -  100%      vnum.
--   ,   1    ,  2  vnum  ,
--     (heap),     heap_coeff *   .
--   ,       .
-- ------------------------------------------------------------
function create_random_from_table(from_table, mob_or_room, container, heap_coeff)
    local create_object, value, obj = mob_or_room.create_object
    for value, value in pairs(from_table) do --     value          value,  
        obj = nil
        if type(value) ~= "table" then --    100% 
            obj = create_object(value)
        elseif value[1] <= Mud.random_percent() then --  (vnum   )  ,    
            obj = create_object(value[2])
            obj.weight = obj.weight * Mud.random_range(1, heap_coeff * value[1])
        end
        if obj and container then --   ,    ,      /  
            obj.to_obj(container)
        end
    end
end
-- ------------------------------------------------------------
--       -  (     ).
-- ------------------------------------------------------------
convert_money_count_to_vnum_table = {
[01] = 1,--  
[02] = 3,--  
[10] = 2,--  
[11] = 5,--     
[12] = 5,--     
[20] = 4,--  
[21] = 5,--     
[22] = 5}--    

function create_money_pile(mob_or_room_or_obj, gold, silver)
    local ovnum, obj = convert_money_count_to_vnum_table[10 * math.min(gold, 2) + math.min(silver, 2)]
    if ovnum then -- vnum  ,     -   - ,    
        obj = mob_or_room_or_obj.create_object(ovnum)
        obj.set_value(0, silver)
        obj.set_value(1, gold)
        obj.cost     = 100 * gold + silver;
        obj.weight   = gold / 5 + silver / 20;
        if ovnum > 2 then --   short_descr    
            obj.short_descr = Mud.money_to_text(gold, silver, false) --        silver  gold
            
            --(gold > 0 and ""..gold..""..gramnumber(gold, " ", " ", " ") or "")
             --               ..(ovnum == 5 and " " or "")
              --              ..(silver > 0 and " "..silver..""..gramnumber(silver, "", "", "") or "")
               --             .." "..gramnumber(silver > 0 and silver or gold, "", "", "")
        end
    else
        Mud.log("Error in create_money_pile() - gold and silver equal zero or negative number(s)")
    end
    return obj --  nil    
end

-- -------------------------------------------------------------
--   % ,  vnum ,  vnum ,       .
-- -------------------------------------------------------------
global_resource_table = {
{40, 300000, 300010, "platinum"},
{50, 300001, 300011, "gold"    },
{50, 300002, 300012, "mithril" },
{60, 300003, 300013, "silver"  },
{60, 300004, 300014, "titanium"},
{70, 300005, 300015, "copper"  },
{70, 300006, 300016, "lead"    },
{70, 300007, 300017, "tin"     },
{100,300008, 300018, "iron"    },
{40, 300020, 300030, "diamond" },
{30, 300021, 300031, "ruby"    },
{30, 300022, 300032, "emerald" },
{30, 300023, 300033, "sapphire"},
{70, 300024, 300034, "garnet"  },
{80, 300025, 300035, "crystal" },
{60, 300026, 300036, "opal"    },
{60, 300027, 300037, "topaz"   },
{70, 300028, 300038, "turquoise"} }
-- -------------------------------------------------------------
--    (position)   
-- (   /    ).
-- -------------------------------------------------------------
global_position_table = {["stand"] = 8,   ["sleep"] = 4, ["fight"] = 7, ["rest"] = 5, ["sit"] = 6, ["stunned"] = 3, ["dead"] = 0,  ["mortal"]  = 1, ["incap"] = 2 }
-- ----------!!!!!!!!!!   !!!!!!-------------
-- !          
--   !        
--    ! delay    !.
-- ------------------------------------------------------------
function system_player_entergame_init(player)
--    World.echo("est kontakt!")
end
-- ------------------------------------------------------------
--        property   victim_or_value. TODO   ch.action  
--   victim_or_value     ,   ch -   .
-- ------------------------------------------------------------
function global_eq_property(ch, property, value)
  --  if ch[_lua_get_class_name
    return ch[property] == value --        ch.    ch[_]
end
-- ------------------------------------------------------------
--       1   2.
-- ------------------------------------------------------------
function global_eq_values(param1, param2)
    return param1 == param2
end
-- ------------------------------------------------------------
--  ,   1   2.
-- ------------------------------------------------------------
function global_compare_values(param1, param2)
    return param1 > param2
end
-- ------------------------------------------------------------
--     ch    (). TODO   global_eq_property
-- ------------------------------------------------------------
function global_check_class(ch, string_class)
    return ch.current_class == string_class
end
-- ------------------------------------------------------------
--     ch   victim.
-- ------------------------------------------------------------
function global_check_levels(ch, victim)
    return ch.level > victim.level
end
-- ------------------------------------------------------------
--   ch  ?
-- ------------------------------------------------------------
function global_check_level_num(ch, number)
    return ch.level > number
end
-- ------------------------------------------------------------
--   PK-  pc- ch ( ,   .)
-- ------------------------------------------------------------
function global_check_pk_effective(ch)
    return ch.is_pc() and (ch.pc_killed > ch.pc_death)
end
-- ------------------------------------------------------------
--    ch -    .  TODO   global_eq_property
-- ------------------------------------------------------------
function global_check_exorcist(ch)
    return ch.superclass == "paladin" and ch.facet == "exorcist"
end
-- ------------------------------------------------------------
--     obj    ,   .  TODO   global_eq_property
-- ------------------------------------------------------------
function global_check_liquid(obj, liquid)
    return obj.type == "drink" and obj.liq_name == liquid
end
-- ------------------------------------------------------------
--  ch.value(index)  obj.value(index)  ?
-- ------------------------------------------------------------
function global_check_value_num(ch_or_obj, index, number)
    return ch_or_obj.value(index) > number
end
-- ------------------------------------------------------------
--     ch    victim. TODO    execute     Victim?
-- ------------------------------------------------------------
function global_ch_execute_victim(ch, victim, command, param)
    ch.execute(command.." "..victim.name..(param and (" "..param) or ""))
end
-- ------------------------------------------------------------
--  true,     ch    /  .
-- ------------------------------------------------------------
function global_check_full_carry(ch)
    return ch.carry_weight_percent < 100 and ch.carry_num_percent < 100
end
-- ------------------------------------------------------------
-- ,   (true)   (   "busy").
--      busy_value - ,       time.
--         get_var/set_var (Area, Room, Char, Obj).
-- ------------------------------------------------------------
function global_check_busy(checked, value, time)
    local busy_value = checked.get_var("busy")
    if not busy_value then
        checked.set_var("busy", value, time or "") -- if time ~= nil then time else "" end
    end
    return busy_value ~= nil -- !    nil 
end
-- ------------------------------------------------------------
--     ch.
-- ------------------------------------------------------------
function global_remove_busy(ch)
    if valid(ch) then
        ch.remove_var("busy")
    end
    return true
end
-- ------------------------------------------------------------
-- ,   -    (value == nil),
--     ( )   .  .
-- ------------------------------------------------------------
function global_exist_var(area_room_ch_obj, name, value)
    local var = area_room_ch_obj.get_var(name)
    if value == nil  then
        return var ~= nil
    else
        return var == value
    end
end
-- ------------------------------------------------------------
--  act  ch.action,    (%s, %d  ..)     (to_act).
-- ------------------------------------------------------------
function global_act(to_act, ch, victim, obj1, obj2, text, ...)
    ch.act(to_act, victim, obj1, obj2, string.format(text, ...))

end
-- ------------------------------------------------------------
--!!!!!!!!    ch.action!!!!!!!!
-- -------------------------------------------------------------
--    .
-- -------------------------------------------------------------
function global_noflee(mob, ch, cmd, arg)
    if ch.is_pc() then
        ch.act("char", "-     .")
    return 1
    end
end
-- ------------------------------------------------------------
--    ,   .
-- ------------------------------------------------------------
function global_nobackstab(obj, ch, cmd, arg)
    if obj.carried_by == ch and obj.is_weared() and not ch.is_morphed() then
        ch.act("char", obj, "$p  $f||||   .");
        return 1
    end
end
-- ------------------------------------------------------------
--   chill_touch (    5 ,  -1 strenght  ).  .
-- ------------------------------------------------------------
function global_set_chill_affect(ch, level)
    local aff = World.create_affect()
    aff.skill = "chill touch"
    aff.origin = "spell"
    aff.duration = 1200 -- 5  * 60  * 4   
    aff.level = level and level or ch.level
    aff.add_apply("str", -1)
    ch.apply_aff(aff, "increment")
    World.destroy_affect(aff)
end
-- ------------------------------------------------------------
--   skill (, blindness, dirt, fire breath)  level  duration .
-- style -   : "cumulative" (,   ), "harmful" (,
--    ), "useful" -  , "increment" (   ).
-- origin  : spell, wand, staff, scroll, food, pill, potion, drink, secondary, 
-- room, hit, skill, raceskill, equipment, nature, quest, rune, script, bio, unknown.
--       apply (, [, , ]).
-- ------------------------------------------------------------
function global_set_affect(ch, skill, style, level, origin, duration, ...)
    local aff, arg = World.create_affect(), {...}
    aff.skill = skill
    aff.level = level
    aff.origin = origin
    aff.duration = duration * 4 --   * 4   
    local i, k, v = next(arg, nil) --    [i] = apply_name ,   v = nil
    while i do  --   nil -   apply
        i, v = next(arg, i) --    [(i)] =  (apply)
        if i then
            aff.add_apply(k, v) --  apply  affect ( aff.add_apply("str", -1))  aff.add_apply("spell", "curse")
        else
            Mud.log("Error in global_set_affect(),  apply ["..k.."] without value undefined.")
            return
        end
        i, k = next(arg, i)
    end
    ch.apply_aff(aff, style)
    World.destroy_affect(aff)
end
-- ------------------------------------------------------------
--    .
-- ------------------------------------------------------------
global_random_hittype_table = { "stab", "slice", "slash", "whip", "claw", "blast", "crush",
"grep", "bite", "pierce", "suction", "beating", "digestion", "charge", "wrath", "magic",
"divine", "cleave", "scratch", "chop", "sting", "smash", "shbite", "flbite", "frbite",
"acbite", "chomp", "drain", "thrust", "shock", "thwack", "flame", "chill"}

function global_random_hittype_change(obj, ch, victim)
    if obj.carried_by == ch and obj.is_weared() then
        obj.hittype = rnd_tab(global_random_hittype_table)
    end    
end
-- ------------------------------------------------------------
--  true,     ch     raceskill  false.
-- ------------------------------------------------------------
global_raceskill_table = {
["sprite_fly"] = 1, ["ethereal_fly"] = 1, ["half-griffon_fly"] = 1, ["halfling_hide"] = 1, ["elf_sneak"] = 1, ["elf_hide"] = 1,
["dwarf_berserk"] = 1, ["giant_bash"] = 1, ["giant_fast healing"] = 1, ["sprite_hide"] = 1, ["centaur_kick"] = 1, ["lizard_envenom"] = 1}

function global_check_raceskill(ch, raceskill)
    return global_raceskill_table[ch.race.."_"..raceskill] ~= nil
end
-- ------------------------------------------------------------
--     _ <= value < _ (  ).
-- ------------------------------------------------------------
function global_table_range(range_table, value_in_range)
--    table.sort(range_table)
    local pairs, i, v, low_index = pairs --  pairs
    for i, v in pairs(range_table) do
        if i == value_in_range then
            return v --       -    
        elseif i < value_in_range and (not low_index or i > low_index) then
            low_index = i
        end
    end
    return (low_index and range_table[low_index] or nil)  --    ,          -  nil
end
-- -------------------------------------------------------------
--    , ,      ,     (   bool_arena).
-- -------------------------------------------------------------
function global_toggle_arena_in_area(area, bool_arena)
    local room, area_not_patched = area.rooms, not area.get_var("arena_patched")
    while room do
        if not room.get_var("real_arena") then --   ,     ,     
            if area_not_patched and room.arena then --             
                room.set_var("real_arena", 1) --       !
            else
                room.arena = bool_arena   --  /  
            end
        end
        room = room.next
    end
    area.set_var("arena_patched", 1) --  ,        
end

-- -------------------------------------------------------------
--            .
-- -------------------------------------------------------------
stdlib_bad_affects_table = {"fancy", "blindness", "faerie fire", "curse", "plague", "poison", "slow", "weaken"}

function global_restore_peace(mob)
    if not mob.get_var("mob_restore_run") then --   ,      
        mob.set_var("mob_restore_run", 1) --       
        local lbat, has_affects, table_insert, table_remove, temp = stdlib_bad_affects_table, {}, table.insert, table.remove
        while mob.position == "stand" do  --     (     ),  
            delay(20, mob) --  mob  - ,  not valid (),    
            if #has_affects == 0 then --         (     ),    
                for i = 1, #lbat do --    ,   
                    temp = lbat[i]
                    if mob.is_affected(temp) then
                        table_insert(has_affects, temp)
                    end
                end
            end
            if mob.hit < mob.max_hit and (Mud.random_percent() > 50 or #has_affects == 0) then --   ,    ,   
                mob.act("all vis_c1", "$n  {Y{x .")
                mob.hit = mob.hit + mob.max_hit / 3
            elseif #has_affects > 0 then
                mob.act("all vis_c1", "$n  {B{x .")
                temp = Mud.random_range(1, #has_affects)
                mob.remove_affect(has_affects[temp])
                table.remove(has_affects, temp)
            else
                break
            end
        end
        mob.remove_var("mob_restore_run") --  ,         
    end
end
-- -------------------------------------------------------------
--      count    vnum      .
-- -------------------------------------------------------------
function global_check_item(ch, vnum, count, check_wear)
    local item, items_table = ch.carrying, {}
    while item and count > 0 do
        if item.vnum == vnum and not (check_wear and item.is_weared()) then --    ( check_wear)?
            heap_count = item.count --     heap () -    ,    - 
            if heap_count == 1 or count >= heap_count then --         ,    
                items_table[item] = 0 --  ,           (  pdf  obj.count)
                count = count - heap_count --  
            elseif count < heap_count then --     ,      
                items_table[item] = heap_count - count --  ,     
                return items_table, 0 --   ,      ,   
            end
        end
        item = item.next_content
    end
    return items_table, count
end
-- -------------------------------------------------------------
-- ,      , , , ,    :
-- price_table = {["money"] = count, ["gold"] = count, ["silver"] = count, ["qp"] = count, [vnum1] = count1, ... [vnumN] = countN} ).
-- money -    gold*100+silver , gold -   , silver -  , qp - .
--        error_message ( format- %s) ---1..separator..---N,  nil.
--  error_message   ,      . 
--   -   ,  --,    reward_vnum.
--   .    -  -         ( if ch.gold < price_table.gold then ...).
-- -------------------------------------------------------------
function global_check_and_buy(mob, ch, reward_vnum, price_table, error_message, separator)
    local error_msg_table, price_items_table, items_table, item, price, count  = {}, {}
    local gold, silver, qp = 0, 0, 0 --        
    if ch.level < 102 then --     
        for item, price in pairs(price_table) do
            if type(item) == "number" then --  vnum
                items_table, count = global_check_item(ch, item, price, true) --          count
                if count > 0 then --  count   ,           
                    table.insert(error_msg_table, World.adj_name(item, 'I', false).." - {W"..(count).."{D "..gramnumber(count, "", "", "")) -- World.adj_name -      
                else
                   table.insert(price_items_table, items_table)
                end
            elseif item == "qp" then --    
                count = price - ch.qpoint
                if count > 0 then
                    table.insert(error_msg_table, "{C"..count.." {Y-"..gramnumber(count, "", "", ""))
                else
                    qp = price
                end
            elseif item == "money" or item == "gold" or item == "silver" then --    , "money" =  + , "gold" =  , "silver" =  
                silver = (item == "gold" and 0 or ch.silver) --        ( 0)
                price = item == "gold" and price * 100 or price --  price    ("gold")   
                count = price - (item == "silver" and 0 or ch.gold * 100) - silver --     ("silver")   
                if count > 0 then
                    table.insert(error_msg_table, Mud.money_to_text(0, count, item ~= "silver")) --     -     99   
                elseif silver < price then --  item == "gold" silver  0,    silver
			        gold = math.floor((price - silver + 99) / 100)
			        silver = price - 100 * gold;
                else
			        silver = price
                end
            else
                Mud.log("[BUG] global_check_and_buy():     - "..item.."    vnum "..reward_vnum)
            end
        end
    end
    if #error_msg_table > 0 then --       ,  -  
        if error_message then --    
            mob.act("victim", ch, string.format(error_message, table.concat(error_msg_table, separator))) --    ()      
        end
        return nil
    else
        for price = 1, #price_items_table do --   #price_items_table   #error_msg_table  0
            items_table = price_items_table[price]
            for item, count in pairs(items_table) do
                item.count = count --  item.count = 0 (),   ,       -
            end
        end
--[[
        for item = 1, #price_items_table do --   #price_items_table   #error_msg_table  0
            items_table = price_items_table[item]
            for count = #items_table, 1, -1 do
                items_table[count].destroy() --     
            end
            items_table = items_table.heap
            if items_table then --   items_table["heap"] (   ,  items_table.heap),  ...
                items_table.obj.count = items_table.count -- ...   ( ,  global_check_item())   -
            end
        end
--]]
        ch.gold = ch.gold - gold
        ch.silver = ch.silver - silver
        ch.qpoints = ch.qpoints - qp
        mob.act("room", ch, "$n   $C-tr .")
        return give_new_obj(mob, ch, reward_vnum)
    end
end
-- -------------------------------------------------------------
--   ,      ch  sneak ( 2      ).
-- ,  ,     greet (     ).
-- -------------------------------------------------------------
function global_see_sneak(mob, ch)
    if not mob.can_see_char(ch) and ch.is_affected("sneak") and Mud.random_percent() < 81 then --     ,  ,  ,   20% ,    ch
        delay(1, mob, ch) --  , sneak     ch
        return mob.room == ch.room and not mob.fighting and not mob.master and mob.is_awaken() and mob.can_see_char(ch)
    end       -- if                                     = return true else return false
    return true --  
end

