local tab = {}
-- ------------------------------------------------------------

function tab.fcopy( t )
    local res = {}
    for k,v in pairs( t ) do
        if type( v ) == "table" then
           res[ k ] = tab.fcopy( v )
        else
           res[ k ] = v
        end   
    end
    return res
end

function tab.merge_toleft( t1, t2 )
    local res = {}
    local t1 = t1 or {}
    local t2 = t2 or {}
    
    res = tab.fcopy( t1 )

    for k,v in pairs( t2 ) do
        local tv = type( v )
        if tv == "table" then
           if type( res[k] ) == "table" then
              res[k] = tab.merge_toleft( res[k] or {}, t2[k] or {} )
           else   
              res[k] = v
           end   
        else
           res[k] = v
        end
    end 
    
    return res
end

function tab.copy( src, dst )

   if src then
      if not dst then dst = {} end
      for field, value in pairs( src ) do
          rawset( dst, field, value )
      end
   end

   return dst
end

function tab.full_copy( src, dst )

   if src then
      if not dst then dst = {} end
      for k,v in pairs( src ) do
          if type( v ) == "table" then
             rawset( dst, k, tab.full_copy( v ) )
          else
             rawset( dst, k, v )
          end
      end
   end

   return dst
end

function tab.rnd( t )
   return t[ math.random( #t ) ]
end

function tab.ver_create( t )

    local res = {}
    for p1, p2 in pairs( t ) do
        for k = 1, p2 do
            table.insert( res, p1 )
        end
    end
    return res
end

function tab.out( ch, t )
   for i = 1,#t do  ch.act( "char", t[i] )  end
end

-- ------------------------------------------------------------
return tab




